<template>
  <auth-layout>
    <v-row class="ma-10">
      <v-col cols="12"></v-col>
    </v-row>
    <v-layout align-center justify-center>
      <v-card elevation="3" outlined width="650">
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
        >
          <v-container class="pa-0">
            <v-row class="ma-10">
              <v-col cols="12">
                <v-img contain max-height="50" src="/images/logo.png"></v-img>
              </v-col>
            </v-row>
            <v-divider class="icon-account-circle"></v-divider>
            <v-row class="ma-10 mt-13">
              <v-col cols="12">
                <label class="d-block text-center text-h5">ĐĂNG NHẬP</label>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  type="email"
                  :rules="rules.emailRules"
                  outlined
                  label="Email"
                  prepend-inner-icon="mdi-account-box-multiple"
                  v-model="form.email"
                  @keydown.enter="login"
                ></v-text-field>
                <v-text-field
                  type="password"
                  :rules="rules.passwordRules"
                  outlined
                  label="Mật khẩu"
                  prepend-inner-icon="mdi-key"
                  v-model="form.password"
                  autocomplete="nope"
                  @keydown.enter="login"
                ></v-text-field>
                <v-checkbox
                  v-model="form.rememberMe"
                  label="Ghi nhớ"
                  :value="1"
                  class="mt-0 pt-0"
                ></v-checkbox>
                <v-btn
                  :disabled="!valid"
                  :height="50"
                  block
                  depressed
                  color="primary"
                  @click="login"
                >
                  ĐĂNG NHẬP
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card>
    </v-layout>
  </auth-layout>
</template>

<script>
import loginService from '../services/authService';

export default {
  data() {
    return {
      valid: false,
      form: {
        email: "nguyen.tinh.rcvn2012@gmail.com",
        password: "111111111",
        rememberMe: null,
      },
      rules: {
        emailRules: [
          v => !!v || 'Email không được trống.',
          v => /.+@.+\..+/.test(v) || 'Email không đúng định dạng.',
        ],
        passwordRules: [
          v => !!v || 'Mật khẩu không được trống.',
          v => v.length > 4 || 'Mật khẩu ít nhất 5 ký tự.',
        ],
      }
    };
  },
  methods: {
    login () {
      const isValid = this.$refs.form.validate();
      if (isValid) {
        this.$store.commit("loading", true);
        loginService.login(this.form).then(response => {
          this.$store.commit("loading", false);
          const data = response.data;
          localStorage.setItem('accessToken', data.accessToken);
          localStorage.setItem('userInfo', JSON.stringify(data.user));
          window.location.href = '/products';
        }).catch(error => {
          this.$store.commit("loading", false);
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.errors;
          }
          this.$store.commit("showMessageError", msgError);
        });
      }
    },
  },
};
</script>
<style scoped>
.icon-account-circle::before {
  content: "";
  position: absolute;
  width: 100px;
  height: 100px;
  background-color: #f3f3f3;
  border: 1px solid #ebdddd;
  border-radius: 50%;
  left: 0;
  right: 0;
  top: 110px;
  margin: auto;
  background-image: url(/images/icon-account.png);
  background-size: contain;
}
.icon-account-circle::after {
  content: "";
}
</style>
